var currentNode;
var currentTable;
let setPage = new Pager();
let edit_actions = {
    bold : "",
    font : "",
    fore : "",
    italic : ""
}
//添加点击 获取当前元素的标签类型
document.addEventListener('click', function (type) {
    //if (!window.webkit || !window.android) return;
    console.log(type.target)
    console.log(type)
    var node = type.target;
    currentNode = node;
    if (node && node.tagName == 'IMG') {
        let dict = {
            action: 'table',
            data: {
                "type": 86
            }
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    } else if (node && node.tagName == 'TD') {
        currentTable = $(node.closest('table'));
        currentRow = $(node).attr('data-row');
        currentCol = $(node).attr('data-col');
        let dict = {
            action: 'table',
            data: {
                "type": 85
            }
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    } else if (node && node.tagName == 'A') {
        let url = $(node).attr('href')
        console.log(node)
        let dict = {
            action: 'table',
            data: {
                "type": 87,
                "url": url
            }
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    } else {
        let cmd = ["bold","italic","underline","strikeThrough","justifyLeft","justifyCenter","justifyRight","fontSize","fontName","backColor","foreColor"];
        let cmdState = {}
        let node = window.getSelection().getRangeAt(0).endContainer;
        node = node.nodeType == 1 ? node : node.parentNode;
        cmd.forEach(i => {
            if(i == "fontSize"){
                cmdState[i] = window.getComputedStyle(node,null).fontSize;
            } else {
                cmdState[i] = document.queryCommandValue(i) ? document.queryCommandValue(i) : document.queryCommandState(i);
            }
        });
        let dict = {
            action: 'elementChanged',
            data: cmdState
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    }
});

//在文档后内容
function insertWordToHtmlContent(html) {
    var _html = decodeURIComponent(html);
    _html = _html.replace(/<br style="page-break-after:always;clear:both;">/g, '');
    var $html = $(_html);
    var $content = "";
    var $draw;
    if (decodeURIComponent(html).indexOf("<html>") != -1) {
        for (var i = 0; i < $html.length; i++) {
            var item = $html[i];
            if (item.tagName == 'DIV') {
                $content += $(item).html();
            }
            if (item.tagName == 'IMG' && ($(item).attr('name') == 'background')) {
                setPageBackground(item.src);
            }
            if (item.tagName == 'IMG' && ($(item).attr('name') == 'draw')) {
                $draw = item;
            }
            if (item.tagName == 'SPAN' && ($(item).attr('name') == 'foot')) {
                setPageFooter(item.innerText);
            }
            if (item.tagName == 'SPAN' && ($(item).attr('name') == 'head')) {
                setPageHeader(item.innerText);
            }
            if (item.tagName == 'P') {
                $content += $(item).html();
            }
            if (item.tagName == 'STYLE') {
                $(document.head).append(item);
            }
        }
    } else {
        $content = $html.html();
    }

    $('.content').html($content);
   $('.content').change();
    $('.content').focus();

    // if (decodeURIComponent(html).indexOf("name=\"draw\"") != -1) {
    //     var img = $('.content').find('img[name="draw"]')
    //     appendDraw(img[0].src);
    //     img.remove()
    // }

    if (decodeURIComponent(html).indexOf("name=\"draw\"") != -1) {
        var img = $('.content').find('img[name="draw"]')
        appendDraw(img);
        img.remove()
    }
    // if (decodeURIComponent(html).indexOf("name=\"background\"") != -1) {
    //     var img = $('.content').find('img[name="background"]')
    //     setPageBackground(img[0].src);
    //     img.remove()
    // }
    // if (decodeURIComponent(html).indexOf("name=\"foot\"") != -1) {
    //     var foot = $('.content').find('span[name="foot"]')
    //     setPageFooter(foot[0].innerText);
    //     // img.remove()
    // }
    // if (decodeURIComponent(html).indexOf("name=\"head\"") != -1) {
    //     var head = $('.content').find('span[name="head"]')
    //     setPageHeader(head[0].innerText)
    //     // img.remove()
    // }

}

//从信息库插入
function insertHtmlContent(content) {
    var _html = decodeURIComponent(content);
    _html = _html.replace(/<br style="page-break-after:always;clear:both;">/g, '');
    var $html = $(_html);
    var $content = "";
    if (_html.indexOf("<html>") != -1) {
        for (var i = 0; i < $html.length; i++) {
            var item = $html[i];
            if (item.tagName == 'DIV') {
                $content = $(item).html();
            }
            if (item.tagName == 'P') {
                $content += $(item).html();
            }
        }
    } else {
        $content = _html;
    }

    SSCommandParams('insertHtml', false, $content);
    let length = fnGetCpmisWords($('.content').text());
    let dict = {
        action: 'updateLength',
        data: {
            "length": length,
            "wordFontSize": 3
        }
    };
    var jsonstr = JSON.stringify(dict);
    if(window.android){
        window.android.postMessage(jsonstr);
    }else if(window.webkit){
        window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
    }

    $(".content").change();
}

//插入内容到光标地方
function insertHtmlAtCaret(html) {
    insertTextAtSelection(decodeURIComponent(html), 'html');
    $('.content').change();

}
//替换整个内容
function replaceWordToHtmlContent(html) {
    html = html.replace("%","%25");
    $('.content').empty();
    $('.content').append(decodeURIComponent(html));
    $('.content').find('div').attr('style', '')
    if (decodeURIComponent(html).indexOf("name=\"draw\"") != -1) {
        var img = $('.content').find('img[name="draw"]')
        appendDraw(img[0].src);
        img.remove()
    }
    if (decodeURIComponent(html).indexOf("name=\"background\"") != -1) {
        var img = $('.content').find('img[name="background"]')
        setPageBackground(img[0].src);
        img.remove()
    }
    $('.content').change();
    //updatePage();

}

//智能核校更新
function replaceCheckContent(id, content) {
    $("#" + id).text(content);
}

function changeContent() {
    $('.content').change();
}
// 获取所有html
function getAllHtml() {
    return $('html').html();
}

function clearContent(){
    $('.content').empty();
    $('.content').change();
}

function getHtmlContent() {
    console.log("getHtmlContent:::");
    var html = $('.content').html();
    $('.dis-content').html(html);
    var $page = $('.dis-content').find('.page-break');

    $page.after('<br style="page-break-after:always;clear:both;" />');
    var html = $('.dis-content').html();
    html = html.replace(/margin-bottom: [0-9.]+px/ig, 'margin-bottom: 0px');
    console.log("html::::" + html);
    return html;
}

function getHtmlContentTxt() {
    var html = $('.content').text();
    return html;
}

///////

function setbackgroundColor(color) {
    /*if (window.getSelection().toString() == "") {
        document.execCommand('BackColor', false, color);
    } else {
        var selecetdHtml = getSelectedHtml({ 'backgroundColor': color });
        document.execCommand('insertHtml', false, selecetdHtml);
        document.execCommand('BackColor', false, color);
    }
    restoreSelection();*/
    document.execCommand('BackColor', false, color);
}

function setFontColor(color) {
    /*if (window.getSelection().toString() == "") {
        document.execCommand('ForeColor', false, color);
    } else {
        var selecetdHtml = getSelectedHtml({ 'fontColor': color });
        document.execCommand('insertHtml', false, selecetdHtml);
        document.execCommand('ForeColor', false, color);
    }*/
    document.execCommand('ForeColor', false, color);
}
//设置字体大小
function setFontSize(size) {
    console.log("FontSize");
    /*if (window.getSelection().toString() == "") {
        document.execCommand('FontSize', false, size);
    } else {
        var selecetdHtml = getSelectedHtml({ 'fontSize': size });
        document.execCommand('insertHtml', false, selecetdHtml);
    }
    $(".content").change();*/
    var fontSize = getFontSize(size);
    document.execCommand("fontSize", false, fontSize);
    var fontElements = window.getSelection().anchorNode.parentNode
    if(fontElements.tagName == 'DIV'){
        return
    }
    fontElements.style.fontSize = size;
}

function getFontSize(size){
    // 1=12px 2=13px 3=16px 4=18px 5=24px 6=32px 7=48px
    size = size.replace('px','');
    size = parseInt(size);
    if(size <= 12){
        return "1";
    }
    if(size > 12 && size <= 13){
        return "2";
    }
    if(size > 13 && size <= 16){
        return "3";
    }
    if(size > 16 && size <= 18){
        return "4";
    }
    if(size > 18 && size <= 24){
        return "5";
    }
    if(size > 24 && size <= 32){
        return "6";
    }
    if(size > 32 && size < 48){
        return "7";
    }
    return "2";
}

function setFontSize1(size) {
    //size 1~7
    document.execCommand('FontSize', false, size);
}
//设置字体
function setFontName(name) {
    /*if (window.getSelection().toString() == "") {
        document.execCommand('fontName', false, name);
    } else {
        var selecetdHtml = getSelectedHtml({ 'fontName': name });
        document.execCommand('insertHtml', false, selecetdHtml);
    }*/
    document.execCommand('fontName', false, name);
}
//设置粗体
function setBold(style) {
    /*var selecetdHtml = getSelectedHtml({ 'fontWeight': style });
    if (selecetdHtml == "") {
        document.execCommand("bold",false,null);  
        return; 
    }
    document.execCommand('insertHtml', false, selecetdHtml);*/
    document.execCommand("bold");
}
//取消粗体
function cancelBold() {
    document.execCommand("bold");
    //    restoreSelection();
}

//设置光标位置
function setCaretPosition(textDom, pos) {
    if (window.setSelectionRange) {
        // IE Support
        window.focus();
        window.setSelectionRange(pos, pos);
    } else if (window.createTextRange) {
        // Firefox support
        var range = window.createTextRange();
        range.collapse(true);
        range.moveEnd('character', pos);
        range.moveStart('character', pos);
        range.select();
    }
}

//设置斜体
function setItalic() {
    /*var selecetdHtml = getSelectedHtml({ 'fontStyle': 'italic' });
    document.execCommand('insertHtml', false, selecetdHtml);*/
    document.execCommand("italic");
}

//取消斜体
function cancleItalic() {
    document.execCommand("italic");
    //    var selecetdHtml = getSelectedHtml({'fontStyle':'normal'});
    //    document.execCommand('insertHtml', false, selecetdHtml);
    //    restoreSelection();
}
//设置删除线
function setStrikeThrough() {
    //var selecetdHtml = getSelectedHtml({ 'textDecoration': 'line-through' });
    //document.execCommand('insertHtml', false, selecetdHtml);
    document.execCommand("strikeThrough");
}
//取消删除线
function cancleStrikeThrough() {
    document.execCommand("strikeThrough");
    //    var selecetdHtml = getSelectedHtml({'textDecoration':'none'});
    //    document.execCommand('insertHtml', false, selecetdHtml);
    //    restoreSelection();
}
//设置下划线
function setUnderLine() {
    //var selecetdHtml = getSelectedHtml({ 'textDecoration': 'underline' });
    //document.execCommand('insertHtml', false, selecetdHtml);
    document.execCommand("underline");
}
//取消下划线
function cancleUnderLine() {
    document.execCommand("underline");
    //    var selecetdHtml = getSelectedHtml({'textDecoration':'none'});
    //    document.execCommand('insertHtml', false, selecetdHtml);
    //    restoreSelection();
}
//设置字体对齐方式
function setTextAlign(align) {
    /*var selecetdHtml = getSelectedHtml({ 'textAlign': align });
    document.execCommand('insertHtml', false, selecetdHtml);
    $(".content").change();*/
    if (align == 'left') {
        align = 'JustifyLeft';
    } else if (align == 'center') {
        align = 'JustifyCenter';
    } else if (align == 'right') {
        align = 'JustifyRight';
    }
    document.execCommand(align);
}
//设置间距

function setLineHeight(height) {
    var selecetdHtml = getSelectedHtml({ 'lineHeight': height });
    document.execCommand('insertHtml', false, selecetdHtml);
    //    restoreSelection();

}
//设置缩进textIndent
function setTextIndent(indent) {
    var selecetdHtml = getSelectedHtml({ 'textIndent': indent });
    document.execCommand('insertHtml', false, selecetdHtml);
    //    restoreSelection();
}

function insertImg(content) {
    SSCommandParams('insertHtml', false, decodeURIComponent(content))
}


function SSCommand(comanand) {
    document.execCommand(comanand)
    $('.content').change();
}

function SSCommandParams(comanand, style, params) {
    console.log(comanand);
    console.log(style);
    console.log(params);
    params = params.replace("%","%25");
    document.execCommand(comanand, style, decodeURIComponent(params))
    $('.content').change();

}

//设置链接
function ssInsertLink(url) {
    restoreSelection();
    let isLink = getLinkText();
    if (isLink) {
        ssCancelLink()
    } else {
        let atext = window.getSelection().toString();
        let atag = '<a href="' + url + '">' + atext + '</a>';
        document.execCommand('insertHtml', false, atag);
    }
    //    restoreSelection();

}


function imageAlign(align) {
    if (align == 'center') {
        console.log(currentNode)
        currentNode.setAttribute('align', align)
    } else {
        currentNode.setAttribute('align', align);
    }
}

function removeNode() {
    if (currentNode) {
        currentNode.remove()
        let dict = {
            action: 'table',
            data: {
                "type": 80
            }
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    }

}

function removeTable() {
    if (currentTable) {
        currentTable.remove()
        let dict = {
            action: 'table',
            data: {
                "type": 80
            }
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    }
}

function removeAll() {
    $('.content').empty();
}

function setLineHeight(height) {
    $('.content').children().css('lineHeight', height)
    //  $('.content').css('lineHeight', height);
}

function SSqueryValue(command) {

   return document.queryCommandValue(command);
}

function insertTextAtSelection(text, mode) {

    var _this = this;
    var sel, range, node;
    mode = mode || '';
    if (window.getSelection) {
        sel = window.getSelection();
        if (sel.getRangeAt && sel.rangeCount) {
            range = sel.getRangeAt(0);
            // range.deleteContents();
            var textNode = document.createTextNode(text);
            if (mode == "html") {
                var el = document.createElement("div");
                el.innerHTML = text;
                var frag = document.createDocumentFragment(),
                    node, lastNode;
                while ((node = el.firstChild)) {
                    lastNode = frag.appendChild(node);
                }
                range.insertNode(frag);
                sel.removeAllRanges();
                range = range.cloneRange();
                sel.addRange(range);
            } else {
                console.log(textNode);
                range.insertNode(textNode);
                range.selectNode(textNode);
            }
        }
    }
}

function getLinkText() {
    selectionRange = window.getSelection().getRangeAt(0);
    var selection = window.getSelection();
    return selection.baseNode.parentNode.tagName == 'A';
}

function ssCancelLink() {
    var sText = window.getSelection();

    document.execCommand('insertHTML', false, '<font face="宋体">' + sText.toString() + '</font>');
    return sText.toString();
}

var new_content = document.getElementById("new_content");

//底部框显示
function layContent() {
    $("#new_content").slideDown("fast");
    setEditReadOnly("false");      //文本区不可编辑
    $(".document").css("overflow","hidden");
    let dict = {
        action: 'layContent',
        data: {
            "type": 1
        }
    };
    var jsonstr = JSON.stringify(dict);
    if(window.android){
        window.android.postMessage(jsonstr);
    }else if(window.webkit){
        window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
    }
}

//底部框隐藏
function hideContent() {
    console.log("hide");
    $("#new_content").hide();
    $(".page .content").attr("contenteditable", "true");
    $(".document").css("overflow","auto");
    let dict = {
        action: 'layContent',
        data: {
            "type": 2
        }
    };
    var jsonstr = JSON.stringify(dict);
    if(window.android){
        window.android.postMessage(jsonstr);
    }else if(window.webkit){
        window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
    }
}

//切换报表,查询缓存
function queryLoadedPort(id) {
    id = parseInt(id);
    var currentPort;
    switch (id) {
        case 1:
            currentPort = JSON.parse(window.sessionStorage.getItem("check_port"));
            break;
        case 2:
            currentPort = JSON.parse(window.sessionStorage.getItem("from_port"));
            break;
        case 3:
            currentPort = JSON.parse(window.sessionStorage.getItem("repeat_port"));
            break;
    }
    let type;
    if(!currentPort.result_content){//为空时显示原文
        type = 1;
    } else {
        replaceWordToHtmlContent(currentPort.result_content);
        type = 2;
    }
    let dict = {
        action: 'contentHtmlChanged',
        data: {
            "type": type
        }
    };
    let jsonstr = JSON.stringify(dict);
    if(window.android){
        window.android.postMessage(jsonstr);
    }else if(window.webkit){
        window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
    }

    if ($(".newlist").attr("data-port") != id) {
        findSource(currentPort.json_data, null, id, null, currentPort.result_content);
        console.log("switch other port");
    }
}

//关闭报表,清除缓存
function closeReport(id) {
    id = parseInt(id);
    if ($(".newlist").attr("data-port") == id) {
        hideContent();
    }
    switch (id) {
        case 1:
            window.sessionStorage.removeItem("check_port");
            break;
        case 2:
            window.sessionStorage.removeItem("from_port");
            break;
        case 3:
            window.sessionStorage.removeItem("repeat_port");
            break;
    }
}

//渲染列表详情
function findSource(json_data, percent, postId, ...rest) {

    // if(percent){
    //     json_data = json_data.replace("(","[");
    //     json_data = json_data.replace(")","]");
    //     json_data = JSON.parse(json_data);
    // }

    var dupScale;
    postId = typeof (postId) == "number" ? postId : parseInt(postId);
    if (postId === 3) {
        if (!rest[0] && window.sessionStorage.getItem("repeat_port")) {
            var repeat_port = JSON.parse(window.sessionStorage.getItem("repeat_port"));
            dupScale = repeat_port.dupScale;
        } else {
            dupScale = rest[0];
        }
    }

    //进度条
    progress(percent);

    //标题栏切换
    $(".titbar-tab").eq(postId - 1).css({
        zIndex: 1,
        opacity: 1
    }).siblings().css({
        zIndex: 0,
        opacity: 0
    });
    //隐藏查重率
    $(".repeat").hide();

    percent = percent ? percent : 100;  //传入pageData以便渲染时判断是否完成

    var pageData = {
        postId,
        dupScale,
        total: json_data.length,
        data: [],
        percent
    }

    //列表分页渲染
    var lastGroup = 0;
    for (var i = 0; i < Math.ceil(pageData.total / 5); i++) {
        pageData.data.push([]);
        for (var j = lastGroup; j < lastGroup + 5; j++) {
            if (json_data[j] == undefined) {
                break;
            }
            json_data[j].rightIndex = j;
            if(!json_data[j].timeSpan && json_data[j].createtime) {
                json_data[j].timeSpan = json_data[j].createtime.split(" ")[0];
            } else if(json_data[j].timeSpan){
                json_data[j].timeSpan = json_data[j].timeSpan.split(" ")[0];
            }
            pageData.data[i].push(json_data[j]);
        }
        lastGroup = j;
    }
    //数据列表
    var html = $("#newlistTemp").render(pageData);
    $(".newlist").html(html).attr("data-port", postId);
    if (postId === 3) {    //查重率
        var html1 = $("#progress-percent-temp").render(pageData);
        $(".dup").html(html1).find(".repeat").show();
    }
    //分页渲染
    var pager = $("#pagerCtrl").render(pageData);
    $(".pagerlist").html(pager);
    if (percent == 100) {
        setPage.init(4, pageData.data.length);
    }
    console.log("渲染结束");
    //判断下一页是否可用
    $(".pager-num").length && $(".pager-num:last").attr("class").indexOf("pager-active") == -1 ?
    $(".pager-next").removeClass("pager-next-unable") : $(".pager-next").addClass("pager-next-unable");
    //判断上一页是否可用
    $(".pager-num").length && $(".pager-num:first").attr("class").indexOf("pager-active") == -1 ?
    $(".pager-prev").removeClass("pager-prev-unable") : $(".pager-prev").addClass("pager-prev-unable");

    //缓存报表数据
    if (percent == 100 && json_data) {
        switch (postId) {
            case 1:
                var check_data = {
                    json_data,
                    result_content: rest[1] ? rest[1] : ""
                }
                window.sessionStorage.setItem("check_port", JSON.stringify(check_data));
                break;
            case 2:
                var from_data = {
                    json_data,
                    result_content: rest[1] ? rest[1] : ""
                }
                window.sessionStorage.setItem("from_port", JSON.stringify(from_data));
                break;
            case 3:
                var repeat_data = {
                    json_data,
                    dupScale,
                    result_content: rest[1] ? rest[1] : ""
                }
                window.sessionStorage.setItem("repeat_port", JSON.stringify(repeat_data));
                break;
        }
    }
}

//加载进度条
function progress(percent) {
    let dis_t = $(".progressbox").width(); //进度总路程
    let $progressbar = $(".progressbar"); //进度条
    let $proPercent = $(".progress-percent"); //进度比
    if (!percent) {
        percent = 100;
        $progressbar.css("width", dis_t * (percent / 100));
        $proPercent.text(percent + "%");
    } else {
        if (percent <= 100) {
            $progressbar.animate({
                width: dis_t * (percent / 100)
            });
            $proPercent.text(percent + "%");
        }
    }
}

//核校文本采纳
function contentAdopt(id,index) {
    let last_port = JSON.parse(window.sessionStorage.getItem("check_port"));
    $(".content span").each((i,span) => {
        if($(span).attr("index") == id){
            let text = last_port.json_data[index].suggestionList[0];
            $(span).text(text);
            $(span).css("color","");
        }
    });
    last_port.json_data.forEach((i, x) => {
        if (x == index) {
            last_port.json_data.splice(x, 1);
        }
    });
    last_port.result_content = $(".content").html();
    window.sessionStorage.setItem("check_port",JSON.stringify(last_port));
    $(".page-item").eq(index).addClass("page-item-leave")
    .on("webkitTransitionEnd msTransitionend mozTransitionend transitionend", function () {
        findSource(last_port.json_data, null, 1, null, last_port.result_content);
    });
}

//核校文本采纳 PAD
function contentAdopt2(index,text) {
    index = parseInt(index);
    $(".content span").each((i,span) => {
        if($(span).attr("index") == index){
            $(span).text(text);
            $(span).css("color","");
        }
    });
}

//核校忽略一次
function ignoreOnce(index) {
    let last_port = JSON.parse(window.sessionStorage.getItem("check_port"));
    last_port.json_data.forEach((i, x) => {
        if (x == index) {
            last_port.json_data.splice(x, 1);
        }
    });
    window.sessionStorage.setItem("check_port",JSON.stringify(last_port));
    $(".page-item").eq(index).addClass("page-item-leave")
        .on("webkitTransitionEnd msTransitionend mozTransitionend transitionend", function () {
            findSource(last_port.json_data, null, 1, null, last_port.result_content);
        });
}

//文章标记锁定列表结果
function showNewWord(index) {
    //当前为核校报表时,确认列表结果带有段落对应标记的check-index锁定
    let $word;
//    if ($(".newlist").attr("data-port") == 1) {
        $(".page-item").each((i, li) => {
            let $li = $(li);
            let id;
            if ($(".newlist").attr("data-port") == 2) {
                id = $li.attr("check-index");
            } else{
                id = $li.attr("check-id");
            }
            if (id == index) {
                $word = $li;
                let $curPage = $li.parents(".newlist-page");
                $(".pager-num").eq($curPage.attr("data-page")).click();
            }
        });
//    } else {
//        $word = $(".page-item").eq(index);
//        let $curPage = $word.parents(".newlist-page");
//        $(".pager-num").eq($curPage.attr("data-page")).click();
//    }
    $word.click();
}

//列表结果锁定文章
function lookingInNewWord(index) {
    index = parseInt(index);
    $(".content span").each((i, item) => {
        if ($(item).attr("index") == index) {
            console.log($(item));
            var offset = $(item).offset().top - 100;
            $(document).scrollTop(offset);
            //选中一段文字
            var range = document.createRange();
            range.selectNodeContents(item);
            var selection = window.getSelection();
            selection.removeAllRanges();
            selection.addRange(range);
        }
    });
}

//打开详情
function showDetails(item,id) {
    let data = { item,id }
    //渲染数据详情内容
    $(".open-details").show();
    let $details = $(".open-details .container");
    let html = $("#details-temp").render(data);
    $details.html(html);
    $(".setmenu").removeClass("setmenu-active");
}

//获取内容拼接P标签
function getNewWordTxt() {
    return $(".content").html();
}

/**
 * 设置尾注，返回内容中添加尾注标记
*/
function setEndNote(postId){
    postId = parseInt(postId);

    let footnotes = "";
    let inx = 1;
    $(".content span").each((index,span) => {
        let $span = $(span);

        if(postId == 2){
            if($span.attr("index")){
                let sup = $(`<a name="supnote" onclick="setTimeForEdit();window.parent.scrollTo(0,document.documentElement.scrollHeight); return false;" style="font-size:12px;text-decoration:none"><sup>[${inx}]</sup></a>`);
                $span.attr("id","notespan" + $span.attr("index"));
                //后面追加一个标记
                $span.after(sup);
                footnotes += `<p write-notes onclick="setTimeForEdit();selNoteForContent('notespan${$span.attr("index")}')" style="font-size:10px;color:#000">[${inx}]
                    ${$span.attr("author") +" 权威性:"+ $span.attr("authoritative") +" 热度:"+ $span.attr("hot") +" 时间:"+ $span.attr("nowdate")}
                </p>`;
                inx++;
            }
        }else if(postId == 3){
            if($span.attr("footnotes")){ 
                let sup = $(`<a name="supnote" onclick="setTimeForEdit();window.parent.scrollTo(0,document.documentElement.scrollHeight); return false;" style="font-size:12px;text-decoration:none"><sup>[${inx}]</sup></a>`);
                $span.attr("id","notespan" + $span.attr("index"));
                //后面追加一个标记
                $span.after(sup);
                footnotes += `<p write-notes onclick="setTimeForEdit();selNoteForContent('notespan${$span.attr("index")}')" style="font-size:10px;color:#000">[${inx}]
                    ${$span.attr("footnotes")}
                </p>`;
                inx++;
            }
        }
    });
    footnotes = "<p><br/></p><p><br/></p><p><br/></p><p><br/></p>" + footnotes;
    $(".content").append($(footnotes));
    let port;
    if(postId == 2){
        port = JSON.parse(window.sessionStorage.getItem("from_port"));
        port.result_content = $(".content").html();
        window.sessionStorage.setItem("from_port",JSON.stringify(port));
    }else if(postId == 3){
        port = JSON.parse(window.sessionStorage.getItem("repeat_port"));
        port.result_content = $(".content").html();
        window.sessionStorage.setItem("repeat_port",JSON.stringify(port));
    }
}

/**
 * 移除尾注和标注内容
*/
function removeNotes(){
    let contentNodes = document.createElement("div");
    contentNodes.innerHTML = $(".content").html();
    let sups = contentNodes.querySelectorAll("a[name=supnote]");
    let notes = contentNodes.querySelectorAll("p[write-notes]");
    //移除段落后的标记，移除尾注内容
    for(let i = 0; i < sups.length; i++){
        sups[i].remove();
        contentNodes.removeChild(notes[i]);
    }
    return contentNodes.innerHTML;
}

/**
 * 选取尾注对应段落
 * 
*/
function selNoteForContent(id){
    let notespan = $(`#${id}`);
    let top = notespan.offset().top;
    let sel = window.getSelection();
    let range = document.createRange();
    range.selectNodeContents(notespan[0]);
    sel.removeAllRanges();
    sel.addRange(range);
    $(document).scrollTop(top - 20);
}

/**
 * 点击跳转时暂时禁用编辑
*/
function setTimeForEdit(){
    if($(".content").attr("contenteditable") == "true"){
        setEditReadOnly("false");
    }
    let timer = setTimeout(function(){
        setEditReadOnly("true");
        clearTimeout(timer);
    },200);
}

$(function () {

    //空白处关闭操作菜单
    $(document).click(function (e) {
        var $setmenu = $(".setmenu");
        if (!$setmenu.is(e.target) && $setmenu.has(e.target).length === 0) {
            $setmenu.removeClass("setmenu-active");
        }
    });

    document.getElementsByClassName("page")[0].ontouchstart = function(){
        document.body.style.overflow = "auto";
    }

    document.getElementsByClassName("newlist")[0].ontouchstart = function(){
            document.body.style.overflow = "hidden";
        }

    //目录锚点定位
    $(".content").on("click","a[href*=_toc]",function(e){
        e.stopPropagation();
        let enable = $(".content").attr("contenteditable");
        setEditReadOnly("false");
        let id = $(this).attr("href");
        let top = $(`.content ${id}`).offset().top - 50;
        $(document).scrollTop(top);
        let timer = setTimeout(function(){
            setEditReadOnly(enable);
            clearTimeout(timer);
        },100);
    });

    //点击返回按钮
    $(".progress-left").click(function () {
        console.log("返回创作");
        const data = {
            action: "closeReport"
        }
        let jsonstr = JSON.stringify(data);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    });

    //单条数据操作
    $(".newlist").on("click", ".page-item", function (e) {
        e.stopPropagation();
        //添加高亮样式
        $(this).addClass("page-item-active").siblings().removeClass("page-item-active");
        let index = $(this).index();
        let postId = $(this).parents(".newlist").attr("data-port");
        //获取核校结果数据的文本标题和具体内容
        if (postId == 1) {
            let check_result = JSON.parse(window.sessionStorage.getItem("check_port")).json_data;
            check_result.forEach((i, x) => {
                if(index == x){
                    showDetails(i,postId);
                }
            });
            let cur_index = parseInt($(this).attr("check-id"));
            lookingInNewWord(cur_index);
        } else if(postId == 2) {
            let from_result = JSON.parse(window.sessionStorage.getItem("from_port")).json_data;
            from_result.forEach((i, x) => {
                if(index == x){
                    showDetails(i,postId);
                }
            });
            let cur_index = parseInt($(this).attr("check-index"));
            lookingInNewWord(cur_index);
        }else{
            let repeat_result = JSON.parse(window.sessionStorage.getItem("repeat_port")).json_data;
            repeat_result.forEach((i, x) => {
                if(index == x){
                    showDetails(i,postId);
                }
            });
            let cur_index = parseInt($(this).attr("check-id"));
            lookingInNewWord(cur_index);
        }
    });

    //更多操作
    $(".newlist").on("click", ".page-item .opera", function (e) {
        e.stopPropagation();
        $(this).find(".setmenu").toggleClass("setmenu-active").parents(".page-item").siblings().find(".setmenu").removeClass("setmenu-active");
    });

    //采纳
    $(".newlist").on("click", ".setmenu .adopt", function (e) {
        e.stopPropagation();
        let $ts = $(e.target).parents(".page-item");
        $ts.find(".setmenu").removeClass("setmenu-active");
        contentAdopt($ts.attr("check-id"),$ts.index());
    });

    //永久忽略
    $(".newlist").on("click", ".setmenu .forever", function (e) {
        e.stopPropagation();
        let $ts = $(e.target).parents(".page-item");
        $ts.find(".setmenu").removeClass("setmenu-active");
        let params = {
                action: 'ignoreForever',
                data: {
                    "id": $ts.index(),
                    "docErrorSetId": $ts.attr("error-setid")
                }
        };
        var jsonstr = JSON.stringify(params);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    });

    //忽略一次
    $(".newlist").on("click", ".setmenu .once", function (e) {
        e.stopPropagation();
        let $ts = $(e.target).parents(".page-item");
        $ts.find(".setmenu").removeClass("setmenu-active");
        ignoreOnce($ts.index());
    });

    //关闭详情
    $(".open-details .close").click(function () {
        $(this).parent().hide();
        $(this).parent().find(".title").empty().next().empty();
    });

    //分页器高亮样式
    $(".pagerlist").on("click", "a.pager-num:not(.pager-prev):not(.pager-next):not(.pager-last)", function (e) {
        e.stopPropagation();
        var page = parseInt($(this).text());
        $(this).addClass("pager-active").parent().siblings().find(".pager-num").removeClass("pager-active");
        $(".page-item.page-item-active").removeClass("page-item-active");
        $(".newlist-page").eq(page - 1).show().siblings().hide();
        $(".setmenu").removeClass("setmenu-active");
        //跳转分页
        setPage.go(page);
        return false;
    });

    //点击上一页
    $(".pagerlist").on("click", "a.pager-prev", function (e) {
        e.stopPropagation();
        setPage.prev();
        return false;
    });

    //点击下一页
    $(".pagerlist").on("click", "a.pager-next", function (e) {
        e.stopPropagation();
        setPage.next();
        return false;
    });

    //点击尾页
    $(".pagerlist").on("click","a.pager-last",function(e){
        e.stopPropagation();
        let page = parseInt($(this).text());
        $(".pager-num.pager-active").removeClass("pager-active");
        $(".page-item.page-item-active").removeClass("page-item-active");
        $(".newlist-page").eq(page - 1).show().siblings().hide();
        $(".setmenu").removeClass("setmenu-active");
        setPage.go(page);
        return false;
    });
});